{
    "$graph": [
        {
            "class": "CommandLineTool",
            "label": "awk",
            "doc": "AWK command",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "ubuntu:18.04",
                    "id": "#ubuntu-docker.yml"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Awk separator",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-F"
                    },
                    "id": "#awk.cwl/F"
                },
                {
                    "type": "File",
                    "doc": "Input file",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#awk.cwl/file"
                },
                {
                    "type": "string",
                    "doc": "Out put file name",
                    "id": "#awk.cwl/outFileName"
                },
                {
                    "type": "string",
                    "doc": "Awk text",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#awk.cwl/text"
                }
            ],
            "stdout": "$(inputs.outFileName)",
            "baseCommand": [
                "awk"
            ],
            "id": "#awk.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#awk.cwl/output",
                    "outputBinding": {
                        "glob": "$(inputs.outFileName)"
                    }
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "grep",
            "doc": "GREP command",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "$import": "#ubuntu-docker.yml"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#grep.cwl/file"
                },
                {
                    "type": "string",
                    "id": "#grep.cwl/outFileName"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#grep.cwl/pattern"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-v"
                    },
                    "id": "#grep.cwl/v"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#grep.cwl/output",
                    "outputBinding": {
                        "glob": "$(inputs.outFileName)"
                    }
                }
            ],
            "stdout": "$(inputs.outFileName)",
            "baseCommand": [
                "grep"
            ],
            "id": "#grep.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "gzip",
            "doc": "Compress files",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "$import": "#ubuntu-docker.yml"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-d"
                    },
                    "id": "#gzip.cwl/d"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#gzip.cwl/file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "${\n  if (inputs.d){\n    return inputs.file.nameroot;\n  }else{\n    return inputs.file.basename + '.gz';\n  }\n}\n"
                    },
                    "id": "#gzip.cwl/output"
                }
            ],
            "stdout": "${\n    if (inputs.d){\n        return inputs.file.nameroot;\n    }else{\n        return inputs.file.basename + '.gz';\n    }\n}\n",
            "baseCommand": [
                "gzip",
                "-c"
            ],
            "id": "#gzip.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "shuf",
            "doc": "SHUF command",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "$import": "#ubuntu-docker.yml"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#shuf.cwl/file"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-n"
                    },
                    "id": "#shuf.cwl/n"
                },
                {
                    "type": "string",
                    "id": "#shuf.cwl/outFileName"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--random-source=",
                        "separate": false
                    },
                    "id": "#shuf.cwl/random-source"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#shuf.cwl/output",
                    "outputBinding": {
                        "glob": "$(inputs.outFileName)"
                    }
                }
            ],
            "stdout": "$(inputs.outFileName)",
            "baseCommand": [
                "shuf"
            ],
            "id": "#shuf.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "split",
            "doc": "SPLIT command",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "$import": "#ubuntu-docker.yml"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-d"
                    },
                    "id": "#split_half.cwl/d"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#split_half.cwl/file"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-l"
                    },
                    "id": "#split_half.cwl/l"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#split_half.cwl/outFileName"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-l",
                        "loadContents": true,
                        "valueFrom": "${\n    var value = (parseInt(inputs.valuefile.contents.split('\\n')[0]) + 1)/2;\n    return value.toString().split('.')[0];\n }\n"
                    },
                    "id": "#split_half.cwl/valuefile"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "$(inputs.outFileName)*"
                    },
                    "id": "#split_half.cwl/output"
                }
            ],
            "baseCommand": [
                "split"
            ],
            "id": "#split_half.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "wc",
            "doc": "WC command",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "$import": "#ubuntu-docker.yml"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-L"
                    },
                    "id": "#wc.cwl/L"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-c"
                    },
                    "id": "#wc.cwl/c"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#wc.cwl/file"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-l"
                    },
                    "id": "#wc.cwl/l"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-m"
                    },
                    "id": "#wc.cwl/m"
                },
                {
                    "type": "string",
                    "id": "#wc.cwl/outFileName"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-w"
                    },
                    "id": "#wc.cwl/w"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#wc.cwl/output",
                    "outputBinding": {
                        "glob": "$(inputs.outFileName)"
                    }
                }
            ],
            "stdout": "$(inputs.outFileName)",
            "baseCommand": [
                "wc"
            ],
            "id": "#wc.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "bedtools-bamtobed",
            "doc": "The bedtools utilities are a swiss-army knife of tools for a wide-range of genomics analysis tasks",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/bedtools:2.28.0--hdf88d34_0",
                    "id": "#bedtools-docker.yml"
                },
                {
                    "class": "SoftwareRequirement",
                    "packages": [
                        {
                            "package": "bedtools",
                            "version": [
                                "2.29.2"
                            ],
                            "specs": [
                                "https://anaconda.org/bioconda/bedtools"
                            ]
                        }
                    ],
                    "id": "#bedtools-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-bed12"
                    },
                    "doc": "Write \u201cblocked\u201d BED (a.k.a. BED12) format. This will convert \u201cspliced\u201d BAM alignments\n(denoted by the \u201cN\u201d CIGAR operation) to BED12. Forces -split.\n",
                    "id": "#bedtools-bamtobed.cwl/bed12"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-bedpe"
                    },
                    "doc": "Write BAM alignments in BEDPE format. Only one alignment from paired-end reads will be reported.\nSpecifically, it each mate is aligned to the same chromosome, the BAM alignment reported will\nbe the one where the BAM insert size is greater than zero. When the mate alignments are\ninterchromosomal, the lexicographically lower chromosome will be reported first. Lastly,\nwhen an end is unmapped, the chromosome and strand will be set to \u201c.\u201d and the start and\nend coordinates will be set to -1. By default, this is disabled and the output will be\nreported in BED format.\n",
                    "id": "#bedtools-bamtobed.cwl/bedpe"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 5,
                        "prefix": "-i"
                    },
                    "doc": "Input BAM format",
                    "id": "#bedtools-bamtobed.cwl/i"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-mate1"
                    },
                    "doc": "When writing BEDPE (-bedpe) format, always report mate one as the first BEDPE \u201cblock\u201d.\n",
                    "id": "#bedtools-bamtobed.cwl/mate1"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-split"
                    },
                    "doc": "Report each portion of a \u201csplit\u201d BAM (i.e., having an \u201cN\u201d CIGAR operation) alignment as\na distinct BED intervals.\n",
                    "id": "#bedtools-bamtobed.cwl/split"
                },
                {
                    "type": "string",
                    "doc": "Stdout from program",
                    "id": "#bedtools-bamtobed.cwl/stdout"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.stdout)"
                    },
                    "id": "#bedtools-bamtobed.cwl/out_stdout"
                }
            ],
            "stdout": "$(inputs.stdout)",
            "baseCommand": [
                "bedtools",
                "bamtobed"
            ],
            "id": "#bedtools-bamtobed.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "label": "Create tagAlign file",
            "doc": "This workflow creates tagAlign file",
            "inputs": [
                {
                    "type": "File",
                    "id": "#create-tagAlign.cwl/bam_file"
                }
            ],
            "outputs": [
                {
                    "outputSource": "#create-tagAlign.cwl/gzip/output",
                    "type": "File",
                    "id": "#create-tagAlign.cwl/output"
                }
            ],
            "steps": [
                {
                    "run": "#awk.cwl",
                    "in": [
                        {
                            "source": "#create-tagAlign.cwl/bamtobed/out_stdout",
                            "id": "#create-tagAlign.cwl/awk/file"
                        },
                        {
                            "valueFrom": "${ return inputs.file.nameroot + \".tagAlign\";}",
                            "id": "#create-tagAlign.cwl/awk/outFileName"
                        },
                        {
                            "default": "BEGIN{OFS=\"\\t\"}{$4=\"N\";$5=\"1000\";print $0}",
                            "id": "#create-tagAlign.cwl/awk/text"
                        }
                    ],
                    "out": [
                        "#create-tagAlign.cwl/awk/output"
                    ],
                    "id": "#create-tagAlign.cwl/awk"
                },
                {
                    "run": "#bedtools-bamtobed.cwl",
                    "in": [
                        {
                            "source": "#create-tagAlign.cwl/bam_file",
                            "id": "#create-tagAlign.cwl/bamtobed/i"
                        },
                        {
                            "valueFrom": "${ return inputs.i.nameroot + \".bed\";}",
                            "id": "#create-tagAlign.cwl/bamtobed/stdout"
                        }
                    ],
                    "out": [
                        "#create-tagAlign.cwl/bamtobed/out_stdout"
                    ],
                    "id": "#create-tagAlign.cwl/bamtobed"
                },
                {
                    "run": "#gzip.cwl",
                    "in": [
                        {
                            "source": "#create-tagAlign.cwl/awk/output",
                            "id": "#create-tagAlign.cwl/gzip/file"
                        }
                    ],
                    "out": [
                        "#create-tagAlign.cwl/gzip/output"
                    ],
                    "id": "#create-tagAlign.cwl/gzip"
                }
            ],
            "id": "#create-tagAlign.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                }
            ],
            "label": "Subsample BAM file creating a tagAlign and pseudoreplicates",
            "doc": "This workflow creates a subsample from a BAM file creating a tagAlign and pseudoreplicates",
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/bam_file"
                },
                {
                    "type": "int",
                    "id": "#main/nreads"
                }
            ],
            "outputs": [
                {
                    "outputSource": "#main/pseudoreplicate_gzip/output",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#main/pseudoreplicate_gzip_out"
                },
                {
                    "outputSource": "#main/gzip/output",
                    "type": "File",
                    "id": "#main/subsample_out"
                },
                {
                    "outputSource": "#main/create_tagalign/output",
                    "type": "File",
                    "id": "#main/tagalign_out"
                }
            ],
            "steps": [
                {
                    "run": "#create-tagAlign.cwl",
                    "in": [
                        {
                            "source": "#main/bam_file",
                            "id": "#main/create_tagalign/bam_file"
                        }
                    ],
                    "out": [
                        "#main/create_tagalign/output"
                    ],
                    "id": "#main/create_tagalign"
                },
                {
                    "run": "#grep.cwl",
                    "in": [
                        {
                            "source": "#main/gzip_cat/output",
                            "id": "#main/filter_chrM/file"
                        },
                        {
                            "valueFrom": "${ return inputs.file.nameroot;}",
                            "id": "#main/filter_chrM/outFileName"
                        },
                        {
                            "default": "chrM",
                            "id": "#main/filter_chrM/pattern"
                        },
                        {
                            "default": true,
                            "id": "#main/filter_chrM/v"
                        }
                    ],
                    "out": [
                        "#main/filter_chrM/output"
                    ],
                    "id": "#main/filter_chrM"
                },
                {
                    "run": "#gzip.cwl",
                    "in": [
                        {
                            "default": true,
                            "id": "#main/gzip/c"
                        },
                        {
                            "source": "#main/shuf/output",
                            "id": "#main/gzip/file"
                        },
                        {
                            "default": true,
                            "id": "#main/gzip/n"
                        },
                        {
                            "valueFrom": "${ return inputs.file.basename + \".gz\";}",
                            "id": "#main/gzip/outFileName"
                        }
                    ],
                    "out": [
                        "#main/gzip/output"
                    ],
                    "id": "#main/gzip"
                },
                {
                    "run": "#gzip.cwl",
                    "in": [
                        {
                            "default": true,
                            "id": "#main/gzip_cat/c"
                        },
                        {
                            "default": true,
                            "id": "#main/gzip_cat/d"
                        },
                        {
                            "source": "#main/create_tagalign/output",
                            "id": "#main/gzip_cat/file"
                        },
                        {
                            "valueFrom": "${ return inputs.file.nameroot;}",
                            "id": "#main/gzip_cat/outFileName"
                        }
                    ],
                    "out": [
                        "#main/gzip_cat/output"
                    ],
                    "id": "#main/gzip_cat"
                },
                {
                    "run": "#wc.cwl",
                    "in": [
                        {
                            "source": "#main/gzip_cat/output",
                            "id": "#main/pseudoreplicate_count_lines/file"
                        },
                        {
                            "default": true,
                            "id": "#main/pseudoreplicate_count_lines/l"
                        },
                        {
                            "valueFrom": "${ return inputs.file.nameroot;}",
                            "id": "#main/pseudoreplicate_count_lines/outFileName"
                        }
                    ],
                    "out": [
                        "#main/pseudoreplicate_count_lines/output"
                    ],
                    "id": "#main/pseudoreplicate_count_lines"
                },
                {
                    "run": "#gzip.cwl",
                    "scatter": [
                        "#main/pseudoreplicate_gzip/file"
                    ],
                    "in": [
                        {
                            "default": true,
                            "id": "#main/pseudoreplicate_gzip/c"
                        },
                        {
                            "source": "#main/pseudoreplicate_split_file/output",
                            "id": "#main/pseudoreplicate_gzip/file"
                        },
                        {
                            "valueFrom": "${ return inputs.file.basename + '.tagAlign.gz';}",
                            "id": "#main/pseudoreplicate_gzip/outFileName"
                        }
                    ],
                    "out": [
                        "#main/pseudoreplicate_gzip/output"
                    ],
                    "id": "#main/pseudoreplicate_gzip"
                },
                {
                    "run": "#split_half.cwl",
                    "in": [
                        {
                            "default": true,
                            "id": "#main/pseudoreplicate_split_file/d"
                        },
                        {
                            "source": "#main/gzip_cat/output",
                            "id": "#main/pseudoreplicate_split_file/file"
                        },
                        {
                            "valueFrom": "${ return inputs.file.nameroot + '.';}",
                            "id": "#main/pseudoreplicate_split_file/outFileName"
                        },
                        {
                            "source": "#main/pseudoreplicate_count_lines/output",
                            "id": "#main/pseudoreplicate_split_file/valuefile"
                        }
                    ],
                    "out": [
                        "#main/pseudoreplicate_split_file/output"
                    ],
                    "id": "#main/pseudoreplicate_split_file"
                },
                {
                    "run": "#shuf.cwl",
                    "in": [
                        {
                            "source": "#main/filter_chrM/output",
                            "id": "#main/shuf/file"
                        },
                        {
                            "source": "#main/nreads",
                            "id": "#main/shuf/n"
                        },
                        {
                            "valueFrom": "${ return inputs.file.nameroot + \".filt.nodup.sample.tagAlign\";}",
                            "id": "#main/shuf/outFileName"
                        },
                        {
                            "source": "#main/gzip_cat/output",
                            "id": "#main/shuf/random-source"
                        }
                    ],
                    "out": [
                        "#main/shuf/output"
                    ],
                    "id": "#main/shuf"
                }
            ],
            "id": "#main",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        }
    ],
    "cwlVersion": "v1.0",
    "$schemas": [
        "https://schema.org/version/latest/schemaorg-current-http.rdf"
    ],
    "$namespaces": {
        "s": "http://schema.org/"
    }
}
